
;; Assuming that snow and rainstorm could be mixed this problem flies from 
;; Seattle to Portland handling both of these conditions

(load-goal '(
	     and
	     (current-position TORONTO)
	     (on-ground)
	     (tank FULL)
	     ))


(load-start-state
 '(

   (angle 10)
   (weather-type RAINSTORM)
   (weather-type HI-WIND)
   (weather-type LOW-WIND)
   (weather-type TURBULENCE)
   (weather-type LOW-PRESSURE)
   (weather-type SUNNY)
   (weather-type SNOW)
   (weather-type HAIL)

   (flap-position UP)
   (flap-position NEUTRAL)            ;; take-off
   (flap-position DOWN)               ;; landing

   (stick-position FRONT)             ;; landing  (descend)
   (stick-position BACK)              ;; take-off (ascend)
   (stick-position LEFT)              ;; turning
   (stick-position RIGHT)             ;; turning
   (stick-position NEUTRAL)           
   
   (gear-position  UP)                ;; after take-off
   (gear-position  DOWN)              ;; before landing

   (rudder-position NEUTRAL)          
   (rudder-position LEFT)
   (rudder-position RIGHT)

   (throttle-level  FULL)
   (throttle-level  MEDIUM)
   (throttle-level  LOW)
   (throttle-level  OFF)

   (runway-state CLEAR)
   (runway-state BUSY)

   (full-tank    2000)
   (tank-level   FULL)
   (tank-level   MEDIUM)
   (tank-level   LOW)
   (tank-level   EMPTY)

   (direction    NORTH)
   (direction    SOUTH)
   (direction    EAST)
   (direction    WEST)

   (switch-type       AIR-CONDITIONING)
   (switch-type       CABIN-PRESSURE-HI)
   (switch-type       CABIN-PRESSURE-LOW)
   (switch-type       WIND-SCREEN-WIPER)
   (switch-type       MAINTAIN-BALANCE-MODE)

   (on-off      ON)
   (on-off      OFF)
   
   (gas-truck-position  NEAR)
   (gas-truck-position  FAR)
	
;;;  cities 

   (city  VANCOUVER)
   (city  SEATTLE  )
   (city  PORTLAND )
   (city  SANFRANCISCO )
   (city  SANJOSE      )
   (city  LOSANGELES   )
   (city  SANDIEGO     )
   (city  TORONTO      )
   (city  CHICAGO      )
   (city  RHINO        )
   (city  HAWAII       )
   (city  NEWYORK      )

   (cityof  VANCOUVER  CANADA)
   (cityof  SEATTLE    USA )
   (cityof  PORTLAND   USA )
   (cityof  SANFRANCISCO USA)
   (cityof  SANJOSE      USA)
   (cityof  LOSANGELES   USA)
   (cityof  SANDIEGO     USA)
   (cityof  TORONTO      CANADA)
   (cityof  CHICAGO      USA)
   (cityof  RHINO        USA)
   (cityof  HAWAII       USA)
   (cityof  NEWYORK      USA)



   
;;; available flight paths

   (path SEATTLE PORTLAND)
   (path LOSANGELES SANDIEGO)
   (path LOSANGELES HAWAII)
   (path PORTLAND SANFRANCISCO)
   (path SANFRANCISCO LOSANGELES)
   (path PORTLAND CHICAGO)
   (path CHICAGO  RHINO)
   
   (path RHINO   SANDIEGO)
   (path SEATTLE VANCOUVER)
   (path VANCOUVER TORONTO)
   (path TORONTO CHICAGO)
   (path TORONTO HUSTON)
   (path TORONTO BOSTON)
   (path CHICAGO SANJOSE)
   (path SANJOSE LOSANGELES)
   (path SANDIEGO LOSANGELES)
   (path LOSANGELES CHICAGO)
   (path CHICAGO    PITTSBURG)
   (path CHICAGO    BOSTON)
   (path CHICAGO    NEWYORK)
   (path CHICAGO    COLUMBUS)
   (path CHICAGO    HUSTON)
   (path BOSTON     NEWYORK)
   (path VANCOUVER  PORTLAND)
   
;;; Current weather forcast 
;;; you can get to the destination only if the weather is sunny or stable
;;; (weather SEATTLE  PORTLAND        STABLE)
;;; it's conceivable that the auto-pilot cannot find any way to handle
;;; the current weather condition so the planner should return the plane
;;; the to the originating airplane


   (weather TORONTO    HUSTON        HI-WIND)
   (weather TORONTO    BOSTON        RAINSTORM)
   (weather TORONTO    BOSTON        SNOW)
   (weather CHICAGO    PITTSBURG     SNOW)
   (weather CHICAGO    BOSTON        SNOW)
   (weather CHICAGO    BOSTON        TURBULENCE)
   (weather CHICAGO    COLUMBUS      LOW-WIND)
   (weather CHICAGO    HUSTON        HI-PRESSURE)
   (weather CHICAGO    NEWYORK       LOW-PRESSURE)
   (weather CHICAGO    SANJOSE       HI-WIND)
   (weather CHICAGO    RHINO         TURBULENCE)

   (weather LOSANGELES CHICAGO       SNOW)
   (weather LOSANGELES CHICAGO       LOW-WIND)

   (weather SEATTLE  PORTLAND        RAINSTORM)
   (weather SEATTLE  PORTLAND        HI-WIND)
   (weather SEATTLE  PORTLAND        TURBULENCE)
   (weather SEATTLE VANCOUVER        RAINSTORM)
   (weather LOSANGELES SANDIEGO      LOW-WIND)
   (weather LOSANGELES HAWAII        RAINSTORM)
   (weather LOSANGELES HAWAII        HI-WIND)
   (weather PORTLAND SANFRANCISCO    LOW-PRESSURE)
   (weather PORTLAND CHICAGO         SUNNY)
   (weather SANFRANCISCO LOSANGELES  HI-WIND)
   
   (weather VANCOUVER  PORTLAND      RAINSTORM)
   (weather VANCOUVER TORONTO        SNOW)
   (weather TORONTO CHICAGO          HI-WIND)
   (weather RHINO SANDIEGO           SNOW)
   (weather SANJOSE LOSANGELES       SUNNY)
   (weather SANDIEGO LOSANGELES      SUNNY)
   (weather BOSTON   NEWYORK         SNOW)
   
   
;;;
;;; Current States
;;;

   (current-position   SEATTLE)             ;; current position
;   (current-position   VANCOUVER)             ;; current position

   (on-ground)
   (gas-truck   NEAR)
   (runway      CLEAR)

;;   (tank        EMPTY)                      ;; (gallons)
   (tank        30)                      ;; (gallons)
   (stick       BACK)
   (flap        NEUTRAL)
   (gear        DOWN)
   (rudder      NEUTRAL)
   (throttle    LOW)

   (switch     AIR-CONDITIONING       OFF)
   (switch     CABIN-PRESSURE-HI      OFF)
   (switch     CABIN-PRESSURE-LOW     OFF)
   (switch     WIND-SCREEN-WIPER      OFF)
   (switch     MAINTAIN-BALANCE-MODE  OFF)
   
   
   ))








