; This goal builds a moutain bike with an optional short back fender and multi-colored
; tassles on the handlebars. Very neat.

(load-goal '(AND (use-op short-Bfender) (use-op multi-tassle) (built-mtn-bike)))

(load-start-state

;necessary equipment for every kind of bike that comes out of my shop.  All of the MAKE-<kind>-BIKE 
; inference rules will have one part of every type from this list. Notice that to add different 
; kinds of frames or sprockets etc... is trivial.  Just toss it in the list and adjust the NEEDS
; and ATTACHES-TO lists (below) and you're set.  This was my goal in this project to make it as 
; easy as possible to add different types of part and different kinds of types of parts with as 
; little hassle as possible.  

      '((a-type-of frame road-frame)
        (attached race-frame itself)
        (attached mtn-frame itself)
	(attached road-frame itself)
	(a-type-of frame mtn-frame)
	(a-type-of frame race-frame)
	(a-type-of Fwheel road-Fwheel)
	(a-type-of Fwheel mtn-Fwheel)
	(a-type-of Fwheel race-Fwheel)
	(a-type-of Bwheel road-Bwheel)
	(a-type-of Bwheel mtn-Bwheel)
	(a-type-of Bwheel race-Bwheel)
	(a-type-of Ftire road-Ftire)
	(a-type-of Ftire mtn-Ftire)
	(a-type-of Ftire race-Ftire)
	(a-type-of Btire road-Btire)
	(a-type-of Btire mtn-Btire)
	(a-type-of Btire race-Btire)
	(a-type-of Fsprocket F3-gear)
	(a-type-of Fsprocket F2-gear)
	(a-type-of Fsprocket F1-gear)
	(a-type-of Bsprocket B5-gear)
	(a-type-of Bsprocket B1-gear)
	(a-type-of seat hard-seat)
	(a-type-of seat cushy-seat)
	(a-type-of handleBars road-hbars)
	(a-type-of handleBars mtn-hbars)
	(a-type-of handleBars race-hbars)
	(a-type-of Rpedal road-Rpedal)
	(a-type-of Rpedal mtn-Rpedal)
	(a-type-of Rpedal race-Rpedal)
	(a-type-of Lpedal road-Lpedal)
	(a-type-of Lpedal mtn-Lpedal)
	(a-type-of Lpedal race-Lpedal)
	(a-type-of Fbrakes top-Fbrakes)
	(a-type-of Fbrakes low-Fbrakes)
	(a-type-of Bbrakes top-Bbrakes)
	(a-type-of Bbrakes low-Bbrakes)
	(a-type-of brake-cable heavy-Bcable)
	(a-type-of brake-cable light-Bcable)
	(a-type-of chain heavy-chain)
	(a-type-of chain light-chain)
	(a-type-of brake-handle road-Bhandle)
	(a-type-of brake-handle mtn-Bhandle)
	(a-type-of brake-handle race-Bhandle)
	(a-type-of gear-shift normal-gear-shift)
	(a-type-of gear-shift precision-gear-shift)
	(a-type-of gear-cable heavy-gear-cable)
	(a-type-of gear-cable light-gear-cable)
	(a-type-of shift-mech normal-shift-mech)
	(a-type-of shift-mech speed-shift-mech)
	(a-type-of fork road-fork)
	(a-type-of fork mtn-fork)
	(a-type-of fork race-fork)
        (a-type-of paint black)
        (a-type-of paint white)
        (a-type-of paint yellow)
        (a-type-of paint hot-pink)

	
; optional stuff.  These can be added by putting "USE-OP <desired part>" in the goal (see above with
; short front fender).  Again, additing parts and types is trivial.

	(a-type-of Bfender short-Bfender)
	(a-type-of Bfender full-Bfender)
	(a-type-of Ffender short-Ffender)
	(a-type-of Ffender full-Ffender)
	(a-type-of chain-guard disk-chain-guard)
	(a-type-of chain-guard full-chain-guard)
	(a-type-of Breflector yellow-Breflector)
	(a-type-of Breflector red-Breflector)
	(a-type-of Freflector yellow-Freflector)
	(a-type-of Freflector red-Freflector)
	(a-type-of mirror round-mirror)
	(a-type-of mirror square-mirror)
	(a-type-of squeeze-horn loud-squeeze-horn)
	(a-type-of squeeze-horn soft-squeeze-horn)
	(a-type-of bell loud-bell)
	(a-type-of bell soft-bell)
	(a-type-of light generator-light)
	(a-type-of light battery-light)
	(a-type-of decal stripes-decal)
	(a-type-of decal flames-decal)
	(a-type-of decal profanity-dcal)
	(a-type-of Lfoot-clip Lmetal-foot-clip)
	(a-type-of Lfoot-clip Lplastic-foot-clip)
	(a-type-of Rfoot-clip Rmetal-foot-clip)
	(a-type-of Rfoot-clip Rplastic-foot-clip)
	(a-type-of grip foam-grip)
	(a-type-of grip tape-grip)
	(a-type-of rack front-rack)
	(a-type-of rack back-rack)
	(a-type-of tassle red-tassle)
	(a-type-of tassle white-tassle)
	(a-type-of tassle multi-tassle)

; my 'dependency list'.  Here you can see that the frame needs paint first, and that the front and 
; back wheels both need their respective front and back tires etc... This can easily be expanded 
; as you add more types of parts to your state.

        (needs frame paint)
	(needs Fwheel Ftire)
	(needs Bwheel Btire)
	(needs Bwheel Bsprocket)
	(needs Rpedal Fsprocket)
	(needs Fbrakes fork)
	(needs chain-guard chain)
	(needs decal paint)

; makes sure parts are connected to right things.  Again, this can easily be expanded as you add more
; type of parts.

	(attaches-to Fwheel fork)
	(attaches-to Bwheel frame)
	(attaches-to Ftire Fwheel)
	(attaches-to Btire Bwheel)
	(attaches-to Fsprocket Rpedal)
	(attaches-to Bsprocket Bwheel)
	(attaches-to seat frame)
	(attaches-to handleBars frame)
	(attaches-to Rpedal frame)
	(attaches-to Lpedal frame)
	(attaches-to Fbrakes fork)
	(attaches-to Bbrakes frame)
	(attaches-to Brake-cable frame)
	(attaches-to gear-cable frame)
	(attaches-to brake-handle handleBars)
	(attaches-to gear-shift frame)
	(attaches-to shift-mech frame)
	(attaches-to fork frame)
	(attaches-to Bfender frame)
	(attaches-to Ffender frame)
	(attaches-to chain-guard Rpedal)
	(attaches-to Breflector frame)
	(attaches-to Freflector frame)
	(attaches-to mirror handleBars)
	(attaches-to squeeze-horn handleBars)
	(attaches-to bell handleBars)
	(attaches-to light handleBars)
	(attaches-to decal frame)
	(attaches-to Lfoot-clip Lpedal)
	(attaches-to Rfoot-clip Rpedal)
	(attaches-to grip handleBars)
	(attaches-to rack frame)
	(attaches-to tassle handleBars)



))













