#|
*******************************************************************************
PRODIGY Version 2.0  
Copyright 1989 by Steven Minton, Craig Knoblock, Dan Kuokka and Jaime Carbonell

The PRODIGY System was designed and built by Steven Minton, Craig Knoblock,
Dan Kuokka and Jaime Carbonell.  Additional contributors include Henrik Nordin,
Yolanda Gil, Manuela Veloso, Robert Joseph, Santiago Rementeria, Alicia Perez, 
Ellen Riloff, Michael Miller, and Dan Kahn.

The PRODIGY system is experimental software for research purposes only.
This software is made available under the following conditions:
1) PRODIGY will only be used for internal, noncommercial research purposes.
2) The code will not be distributed to other sites without the explicit 
   permission of the designers.  PRODIGY is available by request.
3) Any bugs, bug fixes, or extensions will be forwarded to the designers. 

Send comments or requests to: prodigy@cs.cmu.edu or The PRODIGY PROJECT,
School of Computer Science, Carnegie Mellon University, Pittsburgh, PA 15213.
*******************************************************************************|#




; Operators

(setq *OPERATORS* '(

(MAKE-SKIM-MILK
 (params (<product> <amount_product_wanted>
          <amount_ingr_needed> <amount_additive_needed>
          <amount_ingr_available> <amount_additive_available>
          <amount_ingr_to_get> <amount_additive_to_get>
          <amount_ingr_left> <amount_additive_left>))
 (preconds (and (calc_same_ingr <amount_ingr_needed>
                                <amount_product_wanted>)
                (calc_additive <amount_additive_needed>
                               <amount_product_wanted>)
                (dairy_product WHOLE_MILK <amount_ingr_available>)
                (additive ENZYME <amount_additive_available>)
                (update_avail <amount_ingr_needed>
                              <amount_ingr_available>
                              <amount_ingr_to_get>
                              <amount_ingr_left>)
                (update_avail <amount_additive_needed>
                              <amount_additive_available>
                              <amount_additive_to_get>
                              <amount_additive_left>)
                (dairy_product WHOLE_MILK <amount_ingr_to_get>)))
 (effects (
           (del (dairy_product WHOLE_MILK <*amount_ingr_available>))
           (del (additive ENZYME <amount_additive_available>))
           (add (dairy_product WHOLE_MILK <amount_ingr_left>))
           (add (additive ENZYME <amount_additive_left>))
           (add (dairy_product SKIM_MILK <amount_product_wanted>))))) 

(MAKE-CREAM
 (params (<amount_product_wanted>
          <amount_ingr_needed> <amount_additive_needed1>
                               <amount_additive_needed2>
          <amount_ingr_available> <amount_additive_available1>
                                  <amount_additive_available2>
          <amount_ingr_to_get> <amount_additive_to_get>
          <amount_ingr_left> <amount_additive_left1>
                             <amount_additive_left2>))
 (preconds (and (calc_skim_ingr <amount_ingr_needed>
                                <amount_product_wanted>)
                (calc_additive <amount_additive_needed1>
                               <amount_product_wanted>)
                (calc_additive <amount_additive_needed2>
                               <amount_product_wanted>)
                (dairy_product WHOLE_MILK <amount_ingr_available>)
                (additive ALGIN <amount_additive_available1>)
                (additive MONOGLYCERIDE <amount_additive_available2>)
                (update_avail <amount_ingr_needed>
                              <amount_ingr_available>
                              <amount_ingr_to_get>
                              <amount_ingr_left>)
                (update_avail <amount_additive_needed1>
                              <amount_additive_available1>
                              <amount_additive_to_get1>
                              <amount_additive_left1>)
                (update_avail <amount_additive_needed2>
                              <amount_additive_available2>
                              <amount_additive_to_get2>
                              <amount_additive_left2>)
                (dairy_product WHOLE_MILK <amount_ingr_to_get>)))
 (effects (
           (del (dairy_product WHOLE_MILK <*amount_ingr_available>))
           (del (additive ALGIN <amount_additive_available1>))
           (del (additive MONOGLYCERIDE <amount_additive_available2>))
           (add (dairy_product WHOLE_MILK <amount_ingr_left>))
           (add (additive ALGIN <amount_additive_left1>))
           (add (additive MONOGLYCERIDE <amount_additive_left2>))
           (add (dairy_product CREAM <amount_product_wanted>)))))


(MAKE-BUTTER
 (params (<amount_product_wanted>
          <amount_ingr_needed> <amount_additive_needed>
          <amount_ingr_available> <amount_additive_available>
          <amount_ingr_to_get> <amount_additive_to_get>
          <amount_ingr_left> <amount_additive_left>))
 (preconds (and (calc_same_ingr <amount_ingr_needed>
                                <amount_product_wanted>)
                (calc_additive <amount_additive_needed>
                               <amount_product_wanted>)
                (dairy_product CREAM <amount_ingr_available>)
                (additive CULTURE <amount_additive_available>)
                (update_avail <amount_ingr_needed>
                              <amount_ingr_available>
                              <amount_ingr_to_get>
                              <amount_ingr_left>)
                (update_avail <amount_additive_needed>
                              <amount_additive_available>
                              <amount_additive_to_get>
                              <amount_additive_left>)
                (dairy_product CREAM <amount_ingr_to_get>)))
 (effects (
           (del (dairy_product CREAM <*amount_ingr_available>))
           (del (additive CULTURE <amount_additive_available>))
           (add (dairy_product CREAM <amount_ingr_left>))
           (add (additive CULTURE <amount_additive_left>))
           (add (dairy_product BUTTER <amount_product_wanted>))))) 
 
(MAKE-CURDS-WHOLE-MILK
 (params (<amount_product_wanted>
          <amount_ingr_needed> <amount_additive_needed>
          <amount_ingr_available> <amount_additive_available>
          <amount_ingr_to_get> <amount_additive_to_get>
          <amount_ingr_left> <amount_additive_left>))
 (preconds (and (calc_whole_ingr <amount_ingr_needed>
                                <amount_product_wanted>)
                (calc_additive <amount_additive_needed>
                               <amount_product_wanted>)
                (dairy_product WHOLE_MILK <amount_ingr_available>)
                (additive ENZYME <amount_additive_available>)
                (update_avail <amount_ingr_needed>
                              <amount_ingr_available>
                              <amount_ingr_to_get>
                              <amount_ingr_left>)
                (update_avail <amount_additive_needed>
                              <amount_additive_available>
                              <amount_additive_to_get>
                              <amount_additive_left>)
                (dairy_product WHOLE_MILK <amount_ingr_to_get>)))
 (effects (
           (del (dairy_product WHOLE_MILK <*amount_ingr_available>))
           (del (additive ENZYME <amount_additive_available>))
           (add (dairy_product WHOLE_MILK <amount_ingr_left>))
           (add (additive ENZYME <amount_additive_left>))
           (add (dairy_product CURDS <amount_product_wanted>))))) 
 
(MAKE-CURDS-SKIM-MILK
 (params (<amount_product_wanted>
          <amount_ingr_needed> <amount_additive_needed1>
                               <amount_additive_needed2>
          <amount_ingr_available> <amount_additive_available1>
                                  <amount_additive_available2>
          <amount_ingr_to_get> <amount_additive_to_get>
          <amount_ingr_left> <amount_additive_left1>
                             <amount_additive_left2>))
 (preconds (and (calc_skim_ingr <amount_ingr_needed>
                                <amount_product_wanted>)
                (calc_additive <amount_additive_needed1>
                               <amount_product_wanted>)
                (calc_additive <amount_additive_needed2>
                               <amount_product_wanted>)
                (dairy_product SKIM_MILK <amount_ingr_available>)
                (additive ENZYME <amount_additive_available1>)
                (additive ACID <amount_additive_available2>)
                (update_avail <amount_ingr_needed>
                              <amount_ingr_available>
                              <amount_ingr_to_get>
                              <amount_ingr_left>)
                (update_avail <amount_additive_needed1>
                              <amount_additive_available1>
                              <amount_additive_to_get1>
                              <amount_additive_left1>)
                (update_avail <amount_additive_needed2>
                              <amount_additive_available2>
                              <amount_additive_to_get2>
                              <amount_additive_left2>)
                (dairy_product SKIM_MILK <amount_ingr_to_get>)))
 (effects (
           (del (dairy_product SKIM_MILK <*amount_ingr_available>))
           (del (additive ENZYME <amount_additive_available1>))
           (del (additive ACID <amount_additive_available2>))
           (add (dairy_product SKIM_MILK <amount_ingr_left>))
           (add (additive ENZYME <amount_additive_left1>))
           (add (additive ACID <amount_additive_left2>))
           (add (dairy_product CURDS <amount_product_wanted>))))) 


(MAKE-CHEESE
 (params (<amount_product_wanted>
          <amount_ingr_needed> <amount_additive_needed>
          <amount_ingr_available> <amount_additive_available>
          <amount_ingr_to_get> <amount_additive_to_get>
          <amount_ingr_left> <amount_additive_left>))
 (preconds (and (calc_twice_ingr <amount_ingr_needed>
                                <amount_product_wanted>)
                (calc_additive <amount_additive_needed>
                               <amount_product_wanted>)
                (dairy_product CURDS <amount_ingr_available>)
                (additive ENZYME <amount_additive_available>)
                (update_avail <amount_ingr_needed>
                              <amount_ingr_available>
                              <amount_ingr_to_get>
                              <amount_ingr_left>)
                (update_avail <amount_additive_needed>
                              <amount_additive_available>
                              <amount_additive_to_get>
                              <amount_additive_left>)
                (dairy_product CURDS <amount_ingr_to_get>)))
 (effects (
           (del (dairy_product CURDS <*amount_ingr_available>))
           (del (additive ENZYME <amount_additive_available>))
           (add (dairy_product CURDS <amount_ingr_left>))
           (add (additive ENZYME <amount_additive_left>))
           (add (dairy_product CHEESE <amount_product_wanted>))))) 
 

 (ASSUME-NONE
  (params nil)
  (preconds
     (~(dairy_product <product> 0)))
  (effects ((add (dairy_product <product> 0)))))

 ))

(setq *INFERENCE-RULES* '(
                         ))

