


(defun binding-list (var val-list)
  (cond ((null val-list) nil)
        ((null (car val-list)) (binding-list var (cdr val-list)))
        (t (append (list (list (list var (car val-list))))
        (binding-list var (cdr val-list))))))

(defun prev-time (tme prev-time)
   "This function only returns the time immediately previous"
      (cond ((and (is-variable tme)
	          (is-variable prev-time)) 'no-match-attempted)
	    ((is-variable tme) 
	     (while (/= prev-time *end-time*)
                 (list (list (list tme (1+ prev-time))))))
                 
            ((is-variable prev-time)
		(list (list (list prev-time (1- tme)))))

            (t t)))


(defun between (time mindown mintemp)
  (cond ((is-variable mintemp) (binding-list mintemp (between1 time mindown)))
        (t 'no-match-attempted)))

(defun between2 (time mindown mintemp)
  (cond ((is-variable mintemp) (binding-list mintemp (between3 time mindown)))
        (t 'no-match-attempted)))


(defun later-time (tme next-time)
   "This function only returns the time immediately next"
      (cond ((and (is-variable tme)
	          (is-variable next-time)) 'no-match-attempted)
	    ((is-variable tme) 
	     (while (/= next-time *start-time*)
                 (list (list (list tme (1- next-time))))))
            ((is-variable next-time)
		(list (list (list next-time (1+ tme)))))
                  (t t)))



(defun new-defic (time capacity new-def defic)
  (cond 
       ( (and (is-variable defic)(is-variable new-def) 'no-match-attempted))
       ((is-variable defic) 
            (binding-list  defic (list (+ new-def capacity))))
       ((is-variable new-def)
            (binding-list new-def (list (- defic capacity))))
       (t t)
))
 
 (defun maxima (mindown maxtime)
  (cond ((is-variable maxtime) 
          (if (> mindown 1) (binding-list maxtime (list mindown))
                            (binding-list maxtime (list '1)) ))
        (t t)))





(defun between1 (time mindown)
   (do ((result (list time))
       (t1 time (- t1 1)))
        ((eql t1 (+ 1 (- time mindown)))  result)
        (setf result (append (list (- t1 1))  result))))



(defun between3 (time mindown)
   (do ((result (list time))
       (t1 time (+ t1 1)))
        ((eql t1 (- (+ time mindown) 1))  result)
        (setf result (append (list (+ t1 1))  result))))















